﻿using UnityEngine;
using UnityEngine.UI;

public class ContinueButtonController : MonoBehaviour {

	public GameManager gameManager;

	private void Start() {
		Button continueButton = GetComponent<Button>();
		int? lastUnlockedLevel = PlayerPrefsManager.GetLastLevelUnlocked();

		if (lastUnlockedLevel != null && lastUnlockedLevel > 1) {
			continueButton.interactable = true;
			string levelNameAsString = "02 Level_" + (lastUnlockedLevel < 10 ? "0" + lastUnlockedLevel.ToString() : lastUnlockedLevel.ToString());
			continueButton.onClick.AddListener(delegate { gameManager.LoadLevel(levelNameAsString); });
		} else {
			continueButton.interactable = false;
		}
	}
}
