﻿using UnityEngine;

public abstract class Character : MonoBehaviour {
	public int health = 50;
	public float movementSpeed = 1f;
	public Weapon weaponEquipped;
	public GameObject meleeDetectorPrefab;
	protected new Rigidbody rigidbody;
	protected GameObject avatar;

	protected void Start() {
		rigidbody = GetComponent<Rigidbody>();
		avatar = transform.Find("Avatar").gameObject;
		weaponEquipped = new Weapon(20f, 2f); // setting default weapon
	}

	public void TakeDamage(int damage) {
		health = Mathf.Max(health - damage, 0);
		if (health <= 0) {
			Destroy(gameObject);
		}
	}

	protected void Attack() {
		if (!PauseMenuController.isGamePaused) {
			if (weaponEquipped.type.Equals(Weapon.weaponType.Melee)) {
				AttackMelee();
			} else {
				Debug.LogError("Given weapon type is not supported");
			}
		}
	}

	protected void AttackMelee() {
		GameObject meleeDetector = Instantiate(meleeDetectorPrefab, transform, false);
		meleeDetector.transform.rotation = avatar.transform.rotation;
		meleeDetector.transform.position += meleeDetector.transform.up;
		meleeDetector.GetComponent<MeleeDetector>().damage = weaponEquipped.damage;
	}
}