﻿using UnityEngine;

public class MeleeDetector : MonoBehaviour {
	public float damage = 10f;

	private void OnTriggerEnter(Collider collider) {
		if (!transform.parent) {
			Debug.LogError("MeleeDetector instance has no parent attached");
			Destroy(gameObject);
		} else if ((transform.parent.tag == "Player" && collider.CompareTag("Enemy")) ||
			(transform.parent.tag == "Enemy" && collider.CompareTag("Player"))) {

			collider.gameObject.GetComponent<Character>().TakeDamage((int) damage);
			Destroy(gameObject);
		}

		Destroy(gameObject, 0.5f);
	}
}
