﻿using System;
using UnityEngine;

public class PlayerController : Character {
	public float attackCooldown = 1f;
	private bool isAttackPossible = true;

	private new void Start() {
		base.Start();
	}

	private void Update () {
		Move();
		Attack();
	}

	private void Move() {
		float axisHorizontal = Input.GetAxis("Horizontal");
		float axisVertical = Input.GetAxis("Vertical");
	
		transform.Translate(new Vector3(axisHorizontal, 0f, axisVertical) * Time.deltaTime * movementSpeed);
		rigidbody.velocity = new Vector3();
	}

	private new void Attack() {
		if (Input.GetMouseButtonDown(0)) {
			if (isAttackPossible) {
				isAttackPossible = false;
				Invoke("SetAttackPossible", attackCooldown);
				base.Attack();
			}
		}
	}

	private void SetAttackPossible() {
		isAttackPossible = true;
	}
}
