﻿using UnityEngine;
using UnityEngine.UI;

public class InGameUIController : MonoBehaviour {
	public GameObject winPanel;
	public GameObject lossPanel;
	public GameObject gameInfo;

	private Text score;
	private const string scorePrefix = "Score: ";
	private Text enemyCounter;
	private const string enemyCounterPrefix = "Enemies left: ";
	private Text health;
	private const string healthPrefix = "Health: ";
	private Text weaponType;
	private const string weaponTypePrefix = "Weapon type: ";
	private Text ammo;
	private const string ammoPrefix = "Ammo: ";

	private PlayerController playerController;

	void Start () {
		enemyCounter = GameObject.Find("EnemyCounterLabel").GetComponent<Text>();
		//score = GameObject.Find("ScoreLabel").GetComponent<Text>();
		health = GameObject.Find("HealthLabel").GetComponent<Text>();
		//weaponType = GameObject.Find("WeaponTypeLabel").GetComponent<Text>();
		//ammo = GameObject.Find("AmmoLabel").GetComponent<Text>();

		playerController = GameObject.FindGameObjectWithTag("Player").GetComponent<PlayerController>();
	}
	
	void Update () {
		int enemies = GameObject.FindGameObjectsWithTag("Enemy").Length;

		//score.text = scorePrefix + "-"; // TODO
		enemyCounter.text = enemyCounterPrefix + enemies;
		health.text = healthPrefix + playerController.health;
		//weaponType.text = weaponTypePrefix + playerController.weaponEquipped.type.ToString().Substring(0, 3);
		//ammo.text = ammoPrefix + "-" + "/" + "-"; // TODO

		if (playerController.health <= 0) {
			PauseMenuController.isGamePaused = true;
			lossPanel.SetActive(true);
			GameObject.Find("RepeatLevel").GetComponent<Button>().onClick.AddListener(delegate { GameObject.Find("GameManager").GetComponent<GameManager>().LoadLevel(UnityEngine.SceneManagement.SceneManager.GetActiveScene().name); }); // workaround - nie wiem, czemu przycisk nie działa poprawnie... TODO O_o
		} else if (enemies <= 0) {
			PauseMenuController.isGamePaused = true;
			Time.timeScale = 0f;
			if (!winPanel.activeSelf) {
				winPanel.SetActive(true);
				GameObject.Find("NextLevel").GetComponent<Button>().onClick.AddListener(delegate { GameObject.Find("GameManager").GetComponent<GameManager>().LoadNextLevel(); }); // workaround - nie wiem, czemu przycisk nie działa poprawnie... TODO O_o
				int levelNumber = GetLevelNumber();
				if (levelNumber.Equals(GameManager.levelNumber)) {
					GameObject.Find("LevelCompleted").GetComponent<Text>().text = "GAME WON!!!";
					GameObject.Find("NextLevel").SetActive(false);
					PlayerPrefsManager.SetLastLevelUnlocked(1);
				} else {
					PlayerPrefsManager.UnlockLevel(levelNumber + 1);
					PlayerPrefsManager.SetLastLevelUnlocked(levelNumber + 1);
				}
			}
		}
	}

	private int GetLevelNumber() {
		string levelNumberAsString = UnityEngine.SceneManagement.SceneManager.GetActiveScene().name;
		levelNumberAsString = levelNumberAsString.Substring(levelNumberAsString.Length - 2);
		if (levelNumberAsString.StartsWith("0")) {
			levelNumberAsString = levelNumberAsString.Substring(levelNumberAsString.Length - 1);
		}
		int levelNumber = int.Parse(levelNumberAsString);

		return levelNumber;
	}

	//private bool IsThisLevelLast() {
	//	string levelSuffix = (GetLevelNumber() + 1).ToString();
	//	if (levelSuffix.Length == 1) {
	//		levelSuffix = "0" + levelSuffix;
	//	}
	//	string nextLevelName = "02 Level_" + levelSuffix;

	//	return !UnityEngine.SceneManagement.SceneManager.GetSceneByName(nextLevelName).IsValid();
	//}
}
