﻿using UnityEngine;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour {
	static GameManager instance = null;

	private void Awake() {
		InstanceSetup();
		SetUpGameProperties();
	}

	private void InstanceSetup() {
		if (instance != null) {
			Destroy(gameObject);
		} else {
			instance = this;
			DontDestroyOnLoad(gameObject);
		}
	}

	public static int levelNumber = 5;

	private void SetUpGameProperties() {
		PlayerPrefsManager.UnlockLevel(1);
	}

	public void LoadLevel(string sceneName) {
		SceneManager.LoadScene(sceneName);
	}

	public void LoadNextLevel() {
		SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex + 1);
	}

	public void RepeatLevel() {
		SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex);
	}

	public void Quit() {
		Application.Quit();
	}
}
