﻿using System;
using UnityEngine;

public class PauseMenuController : MonoBehaviour {

	public static bool isGamePaused = false;
	public GameObject pauseMenuUI;

	private void Start() {
		Resume();
	}

	void Update () {
		if (Input.GetKeyDown(KeyCode.Escape)) {
			if (isGamePaused) {
				Resume();
			} else {
				Pause();
			}
		}
	}

	public void Resume() {
		pauseMenuUI.SetActive(false);
		Time.timeScale = 1f;
		isGamePaused = false;
	}

	private void Pause() {
		pauseMenuUI.SetActive(true);
		Time.timeScale = 0f;
		isGamePaused = true;
	}

	public void ReturnToMenu() {
		Resume();
		FindObjectOfType<GameManager>().LoadLevel("01a MainMenu");
	}
}
