﻿using UnityEngine;
using UnityEngine.UI;

public class OptionsController : MonoBehaviour {
	public Slider difficultySlider, musicVolumeSlider, soundEffectsVolumeSlider;
	public GameManager gameManager;
	public MusicManager musicManager;

	void Start() {
		SetUpOptions();
	}

	private void SetUpOptions() {
		if (!PlayerPrefs.HasKey(PlayerPrefsManager.DIFFICULTY_KEY)) {
			PlayerPrefsManager.SetDifficulty(PlayerPrefsManager.DIFFICULTY_DEFAULT);
		}
		difficultySlider.value = PlayerPrefsManager.GetDifficulty();

		if (!PlayerPrefs.HasKey(PlayerPrefsManager.MUSIC_VOLUME_KEY)) {
			PlayerPrefsManager.SetMusicVolume(PlayerPrefsManager.MUSIC_VOLUME_DEFAULT);
		}
		musicVolumeSlider.value = PlayerPrefsManager.GetMusicVolume();

		if (!PlayerPrefs.HasKey(PlayerPrefsManager.SOUND_EFFECTS_VOLUME_KEY)) {
			PlayerPrefsManager.SetSoundEffectsVolume(PlayerPrefsManager.SOUND_EFFECTS_VOLUME_DEFAULT);
		}
		soundEffectsVolumeSlider.value = PlayerPrefsManager.GetSoundEffectsVolume();
	}

	public void SetDefaults() {
		difficultySlider.value = PlayerPrefsManager.DIFFICULTY_DEFAULT;
		musicVolumeSlider.value = PlayerPrefsManager.MUSIC_VOLUME_DEFAULT;
		soundEffectsVolumeSlider.value = PlayerPrefsManager.SOUND_EFFECTS_VOLUME_DEFAULT;
		UpdatePlayerPrefs();
	}

	private void UpdatePlayerPrefs() {
		PlayerPrefsManager.SetDifficulty(difficultySlider.value);
		PlayerPrefsManager.SetMusicVolume(musicVolumeSlider.value);
		PlayerPrefsManager.SetSoundEffectsVolume(musicVolumeSlider.value);
	}

	public void SetDifficulty() {
		PlayerPrefsManager.SetDifficulty(difficultySlider.value);
	}

	public void SetMusicVolume() {
		musicManager.GetComponent<AudioSource>().volume = musicVolumeSlider.value;
		PlayerPrefsManager.SetMusicVolume(musicVolumeSlider.value);
	}

	public void SetSoundEffectsVolume() {
		PlayerPrefsManager.SetSoundEffectsVolume(soundEffectsVolumeSlider.value);
	}
}