﻿using UnityEngine;
using UnityEngine.SceneManagement;

public class SplashScreenController : MonoBehaviour {
	public GameManager gameManager;
	public float splashScreenMinSecondsLength = 2.5f;

	private void Start() {
		SplashScreenSoundHandler();
	}

	private void SplashScreenSoundHandler() {
		if (SceneManager.GetActiveScene().buildIndex == 0 &&
				SceneManager.GetActiveScene().name.ToString().ToLower().Contains("splash")) {
			AudioSource slashScreenAudioSource = GetComponent<AudioSource>();
			slashScreenAudioSource.volume = PlayerPrefsManager.GetMusicVolume();
			float splashScreenDuration = slashScreenAudioSource.clip != null ? Mathf.Max(slashScreenAudioSource.clip.length, splashScreenMinSecondsLength) : splashScreenMinSecondsLength;
			slashScreenAudioSource.Play();

			gameManager.Invoke("LoadNextLevel", splashScreenDuration);
		} else {
			Debug.LogWarning(name + " instantieted in wrong scene.");
		}
	}
}
